﻿using System;
using System.Linq;
using System.Text;
using JustinAngel.MetroBlog.Services.Repository;
using Microsoft.Practices.Unity;

namespace JustinAngel.MetroBlog.Services.Data
{
    public partial class BlogPost
    {
        [Dependency]
        protected IRepository<PostCategory> PostCategoryRepository { get; set; }

        public void SetTitleToPermlink(string title)
        {
                    // do not change permlink aftert it was initialized
            if (!string.IsNullOrEmpty(Permlink))
                return;

            StringBuilder sb = new StringBuilder();
            if (!string.IsNullOrEmpty(title))
            {
                string[] AllowedCharcatersInTitleURL = new string[]
                                                           {
                                                               "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k",
                                                               "l", "m", "n", "o", "p",
                                                               "q", "r", "s", "t", "u", "v", "w", "x", "y", "z",
                                                               "1", "2", "3", "4", "5", "6", "7", "8", "9", "0"
                                                           };

                bool IsLastCharAllowed = false;
                foreach (char curChar in title)
                {
                    bool IsCurCharAllowedInURL = AllowedCharcatersInTitleURL.Contains(curChar.ToString().ToLower());

                    if (IsCurCharAllowedInURL)
                    {
                        // if the last char is allowed - make this char lower case
                        if (IsLastCharAllowed)
                            sb.Append(curChar.ToString().ToLower());
                            // or if the last char wasn't allowed, make this char uppper case
                        else
                            sb.Append(curChar.ToString().ToUpper());
                    }

                    IsLastCharAllowed = IsCurCharAllowedInURL;
                }
            }
            
            if (!string.IsNullOrEmpty(sb.ToString()))
                Permlink = sb.ToString();
            else
                Permlink = Guid.NewGuid().ToString();
        }
    }
}
