﻿using System.ServiceModel;
using System.ServiceModel.Syndication;
using System.ServiceModel.Web;

namespace JustinAngel.MetroBlog.UI.Core.Feeds
{
    [ServiceContract]
    [ServiceKnownType(typeof(Atom10FeedFormatter))]
    [ServiceKnownType(typeof(Rss20FeedFormatter))]
    public interface IFeed
    {
        [OperationContract]
        [WebGetAttribute(UriTemplate = "Get/{format}")]
        SyndicationFeedFormatter GetMainFormat(string format);

        [OperationContract]
        [WebGetAttribute(UriTemplate = "Get/{format}/{username}")]
        SyndicationFeedFormatter GetBlog(string format, string username);

        [OperationContract]
        [WebGetAttribute(UriTemplate = "Get/{format}/{username}/{category}")]
        SyndicationFeedFormatter GetCategory(string format, string username, string category);
    }
}
