﻿using System;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using JustinAngel.MetroBlog.Common.IoC;
using JustinAngel.MetroBlog.Services.BlogPostService;
using Microsoft.Practices.Unity;

namespace JustinAngel.MetroBlog.Controllers
{
    public class ArticleConstraint : IRouteConstraint
    {
        public ArticleConstraint()
        {
            IoC.BuildUp(this);
        }

        [Dependency]
        public IBlogPostService BlogPostService { get; set; }

        public bool Match(HttpContextBase httpContext, Route route, string parameterName, RouteValueDictionary values, RouteDirection routeDirection)
        {
            if (!values.ContainsKey(parameterName))
                return false;

            var articlePermLink = (string)values[parameterName];

            return BlogPostService.Exists(articlePermLink);
        }
    }
}
