using System.Web.Mvc;
using JustinAngel.MetroBlog.Common.IoC;
using JustinAngel.MetroBlog.UI.Core.Feeds;
using JustinAngel.MetroBlog.Views.Syndication;
using Microsoft.Practices.Unity;

namespace JustinAngel.MetroBlog.Controllers
{
    [OutputCache(Duration = 60 * 15, VaryByParam = "none")]
    public class FeedController : Controller
    {
        public FeedController()
        {
            IoC.BuildUp(this);
        }

        [Dependency]
        public IFeed Feed { get; set; }

        public ActionResult GetBlog(string format, string username)
        {
            return new SyndicationView(Feed.GetBlog(format, username));
        }

        public ActionResult GetCategory(string format, string username, string category)
        {
            return new SyndicationView(Feed.GetCategory(format, username, category));
        }

        public ActionResult GetMain(string format)
        {
            return new SyndicationView(Feed.GetMainFormat(format));
        }
    }
}
